;****************************************************************;
;				<<< BOLZ3D.LSP >>>					;
;****************************************************************;
;
;Autor: K.Habenicht
;Datum der Erstellung: 26.4.1993
;Funktion: Variantenkonstruktion eines 3D-Bolzens mit Splintloch

;*************************** Programm ***************************;

;Fehlerroutine
(defun *error* (msg)
(setvar "CMDECHO" cmd)
(setvar "BLIPMODE" blip)
(princ)
)

(defun bolzen (/ PE bd bl fl sd ab P1 P2 P3 P4 MP1 MP2 Zyl Zyl1
 				Zyl2 as as1 as2 Ks1 Ks2)
	(setq PE (getpoint "\nEinfuegepunkt: "))
	(setq bd (getreal "\nBolzendurchmesser: "))
	(setq bl (getreal "\nBolzenlaenge: "))
	(setq fl (getreal "\nFasenlaenge: "))
	(setq sd (getreal "\nDurchmesser des Splintlochs: "))
	(setq ab (getreal "\nAbstand des Splintlochs: "))
	;Berechnen der Punktkoordinaten
	(setq P1 (list (- (car PE) (/ bl 2.0)) (cadr PE)))
	(setq P2 (list (+ (car PE) (/ bl 2.0)) (cadr PE)))
	(setq P3 (list (+ (car P1) fl) (cadr PE)))
	(setq P4 (list (- (car P2) fl) (cadr PE)))
	(setq MP1 (list (+ (car P1) ab) (cadr PE) (- 0 bd)))
	(setq MP2 (list (- (car P2) ab) (cadr PE) (- 0 bd)))
	;Dichte der Tesselationslinien auf 6 stellen
	(solvar "SOLWDENS" 6)
 
	;Zylindrischen Bolzen erzeugen
	(setq Zyl (SOLZYL P3 "d" bd "m" P4))
	;Erste Bohrung
	(setq Zyl1 (SOLZYL MP1 "d" sd (* bd 2.0)))
	;Einen Auswahlsatz fr SOLDIFF erzeugen
	(setq as2 (ssadd Zyl1))
	(setq Zyl2 (SOLZYL MP2 "d" sd (* bd 2.0)))
	;Zweite Bohrung dem Auswahlsatz as2 hinzufgen
	(setq as2 (ssadd Zyl2 as2))
	;BKS verschieben
	(command "BKS" "u" P4)
	;und um y-Achse drehen
	(command "BKS" "y" 90)
	;Kreis fr Extrusion erzeugen
	(command "KREIS" '(0 0 0) "d" bd)
	;Auswahlsatz fr SOLEXTRUS erzeugen
	(setq as (ssget "L"))
	;Mit Solextrus den ersten Kegelstumpf erzeugen
	(setq Ks1 (SOLEXT as fl 30))
	;Auswahlsatz as1 fr SOLDIFF aus Zylinder und ersten Kegelstumpf
	(setq as1 (ssadd Zyl Ks1))
	;BKS fr zweiten Kreis einrichten
	(command "BKS" "w")
	(command "BKS" "u" P3)
	(command "BKS" "y" -90)
	(command "KREIS" '(0 0 0) "d" bd)
	(setq as (ssget "L"))
	;Zweiten Kegelstumpf erzeugen
	(setq Ks2 (SOLEXT as fl 30))
	;und den Extrusionskrper dem Auswahlsatz as1 hinzufgen
	(setq as1 (ssadd (ssname Ks2 0) as1))
	;Auswahlstze voneinander subtrahieren
	(SOLDIFF as1 as2)
	;BKS wieder auf Welt stellen
	(command "BKS" "w")
)

;Prfroutine, ob AME 2.0 geladen ist.
(defun C:BOLZ3D( / aus)
	(setq aus 0)
	;Sichern der Systemvariablen
	(setq cmd (getvar "CMDECHO"))
	(setq blip (getvar "BLIPMODE"))
	(setvar "cmdecho" 0)
	(setvar "BLIPMODE" 0)
	(if (not SOLDIFF)
	(progn
	(princ "\n Diese Funktion luft nur, wenn AME 2.0 geladen ist.")
	(setq aus 1)))
 
	;Start des eigentlichen Programms
	(if (/= aus 1) (bolzen))
	(setvar "cmdecho" cmd)
	(setvar "BLIPMODE" blip)
	(princ)
)
